# ---------------------------------------------------------------------------
# StateDGI_Canals.py
# Test script fot the StateDGI tool.
#Intersect parameter shapefiles with RGDSS Task 3.1 model output and 
#load into geodatabase with assigned name.
# ---------------------------------------------------------------------------
#
#
# Import system modules
import sys, string, math, time, os, win32com.client

# Create the Geoprocessor object
gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")

# Declare script arguments...
DGIDatabase = sys.argv[1]
canals = sys.argv[2]
canals_wt_att = sys.argv[3]
canals_wt_val = 1
weight = sys.argv[4]

#Assign work environment
#Check that model parameters have been selected.
#Delete existing files from database and over-write with new
#model run versions.
gp.Workspace = DGIDatabase
gp.overwriteoutput = 1

#Write Parameters and date to log file
d = os.path.dirname(DGIDatabase)
out = open(d + "/log.txt","w")

out.write("#Date and Time\n")
out.write(time.asctime()+ "\n")
out.write("#Geodatabase\n")
out.write(DGIDatabase + "\n")
out.write("#Canals Shapefile\n")
out.write(canals + "\n")
out.write("#weight attribute\n")
out.write(canals_wt_att + "\n")
out.write("#weight shapefile\n")
out.write(weight + "\n")

if canals != "#":
    if gp.Exists("canals"):
        gp.delete("canals")
    gp.addmessage("Loading Canals shapefile")
    gp.CopyFeatures(canals, DGIDatabase + os.sep + "canals")
    out.write("#gp.CopyFeatures(canals, DGIDatabase\n")
    
if weight != "#":
    if gp.Exists("can_weight"):
        gp.delete("can_weight")
    gp.FeatureClassToGeodatabase(weight, DGIDatabase)
    out.write("#gp.FeatureClassToGeodatabase(weight, DGIDatabase)\n")
    temp = os.path.basename(weight)
    tmp = temp.split(".")
    gp.rename(tmp[0], "can_weight")
    
#Add Weight values to shapefiles.

if canals != "#":
    gp.addmessage("Adding canals weights")
    if canals_wt_att != "#":
        if string.upper(canals_wt_att) != "WEIGHT":
            gp.addfield ("canals", "Weight", "double", "12", "2")
            gp.calculatefield ("canals", "Weight",canals_wt_att)
            out.write("#gp.calculatefield ('canals', 'Weight',canals_wt_att)\n")
    elif weight != "#":
        if gp.Exists("canals_tmp"):
            gp.delete("canals_tmp")
        gp.Intersect_analysis("canals;weight", "canals_tmp",)
        out.write("#gp.Intersect_analysis('canals;weight', 'canals_tmp',)\n")
        gp.delete("canals")
        gp.rename("canals_tmp","canals")
    else:
        gp.addfield("canals", "Weight", "double", "6", "2")
        gp.calculatefield ("canals", "Weight",1)
        out.write("#gp.calculatefield ('canals', 'Weight',1)\n")
               
    if gp.Exists("canal_aka"):
        gp.delete("canal_aka")
    gp.CreateTable(DGIDatabase, "canal_aka")
    gp.AddField("canal_aka","Canal_MSID","text", "20")
    gp.AddField("canal_aka","SW_WDID","text", "20")

        
#Perform Model Intersection.
if gp.exists("model"):
    gp.addmessage("Intersecting Input Shapefiles with Model")
    if gp.exists("canals"):
        gp.addmessage("Intersecting canals")
        if gp.Exists("canal_cells"):
            gp.delete("canal_cells")
        gp.Intersect_analysis("model ; canals ", "canal_cells")

gp.compact(DGIDatabase)


out.close()