# ---------------------------------------------------------------------------
# StateDGI_GroundCover.py
# Test script fot the StateDGI tool.
#Intersect parameter shapefiles with RGDSS Task 3.1 model output and 
#load into geodatabase with assigned name.
# ---------------------------------------------------------------------------
#
#
# Import system modules
import sys, string, math, time, os, win32com.client

# Create the Geoprocessor object
gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")

# Declare script arguments...
DGIDatabase = sys.argv[1]
ground_cover = sys.argv[2]
ground_cover_id = sys.argv[3]
#ground_cover_wt_att = sys.argv[3]
#ground_cover_wt_val = sys.argv[4]
weight = sys.argv[4]
#etz_table = sys.argv[6]


#Assign work environment
#Check that model parameters have been selected.
#Delete existing files from database and over-write with new
#model run versions.
gp.Workspace = DGIDatabase
gp.overwriteoutput = 1

#Write Parameters and date to log file
gp.addmessage("Writing log file")
d = os.path.dirname(DGIDatabase)
out = open(d + "/log.txt","w")

out.write("#Date and Time\n")
out.write(time.asctime()+ "\n")
out.write("#Geodatabase\n")
out.write(DGIDatabase + "\n")
out.write("#Ground Cover Shapefile\n")
out.write(ground_cover + "\n")
#out.write("#Ground Cover Weight Value\n")
#out.write(ground_cover_wt_va + "\n")
out.write("#Ground Cover Weight\n")
out.write(weight + "\n")
#out.write("#Ground Cover ETZ Table\n")
#out.write(etz_table + "\n")

if ground_cover != "#":
    if gp.Exists("ground_cover"):
        gp.delete("ground_cover")
    gp.addmessage("Dissolving Groundcover Shapefile on attribute " + ground_cover_id)
    gp.Dissolve(ground_cover,DGIDatabase + os.sep + "ground_cover",ground_cover_id)
    out.write('gp.Dissolve(ground_cover,DGIDatabase + os.sep + "ground_cover",ground_cover_id)' + "\n")
   
if weight != "#":
    if gp.Exists("weight"):
        gp.delete("weight")
    gp.FeatureClassToGeodatabase(weight, DGIDatabase)
    out.write('gp.FeatureClassToGeodatabase(weight, DGIDatabase)' + "\n")
    temp = os.path.basename(weight)
    tmp = temp.split(".")
    gp.rename(tmp[0], "weight")
    
#Add Weight values to shapefiles.
if ground_cover != "#":
    gp.addmessage("Adding ground_cover weights")
    if weight != "#":
        if gp.Exists("ground_cover_tmp"):
            gp.delete("ground_cover_tmp")
        gp.Intersect_analysis("ground_cover;weight", "ground_cover_tmp",)
        out.write('gp.Intersect_analysis("ground_cover;weight", "ground_cover_tmp",)' + "\n")
        gp.delete("ground_cover")
        gp.rename("ground_cover_tmp","ground_cover")
    else:
        gp.addfield("ground_cover", "Weight", "double", "6", "2")
        gp.calculatefield ("ground_cover", "Weight",1)
        out.write('gp.calculatefield ("ground_cover", "Weight",1)' + "\n")

if ground_cover != "#":
    gp.addfield ("ground_cover", "Layer", "short", "4")
    gp.calculatefield ("ground_cover", "Layer",1)
    out.write('gp.calculatefield ("ground_cover", "Layer",1)' + "\n")
    if ground_cover_id != "ID":
        gp.addfield ("ground_cover", "ID", "text", "32")
        gp.calculatefield ("ground_cover", "ID","[" + ground_cover_id + "]")
        out.write('gp.calculatefield ("ground_cover", "ID","[" + ground_cover_id + "]")' + "\n")
#commented out this to make cover id
#if gp.Exists("cover_id"):
 #   gp.delete("cover_id")
#out.write('gp.CreateTable(DGIDatabase, "cover_id")' + "\n")
#gp.AddField("cover_id","ground_cover_id","text", "40")
#gp.AddField("cover_id","etz_id","text", "40")
#out.write('added fields "cover_id"' + "\n")

#if etz_table != "#":
#    wCur = gp.InsertCursor("cover_id")
#    gp.addmessage("Loading ET Zone Alias file")
#    f = open(etz_table)
#    out.write('open(etz_table)' + "\n")
#    for line in f.readlines():
#        if not line.startswith("#"):
#            id = line.strip().split(",")
#            wRow = wCur.NewRow()
#            wRow.ground_cover_id = id[0]
#            wRow.etz_id = id[1]
#            wCur.InsertRow(wRow)
#    f.close()
#    out.write('close(etz_table)' + "\n")

                
#Perform Model Intersection.
if gp.exists("model"):
    gp.addmessage("Intersecting Input Shapefiles with Model")
    if gp.exists("ground_cover"):
        gp.addmessage("Intersecting ground_cover")
        if gp.Exists("ground_cover_cells"):
            gp.delete("ground_cover_cells")
        gp.Intersect_analysis("model ; ground_cover ", "ground_cover_cells")
        out.write('gp.Intersect_analysis("model ; ground_cover ", "ground_cover_cells")' + "\n")
        

gp.compact(DGIDatabase)


out.close()