# ---------------------------------------------------------------------------

# Import system modules
import sys, string, math, time, os, win32com.client

# Create the Geoprocessor object
gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")

# Check out any necessary licenses

# Script arguments...
canals = sys.argv[1]
canals_id = "SW_WDID"
out_file = sys.argv[2]

try:
    wksp = os.path.dirname(canals)
    gp.Workspace = wksp
    gp.Statistics(os.path.basename(canals), "temp.dbf","length sum",canals_id)

    gp.addmessage("Writing output file")
    out = open(out_file,"w")

    out.write("#Date and Time |" + time.asctime()+ "\n")
    out.write("#Canals Theme |" + canals + "\n")
    out.write("#SW_WDID Field |" + canals_id + "\n")

    rows = gp.SearchCursor("temp.dbf")
    row = rows.Next()
    while row:
        l_str = "%.2f" %(row.GetValue("sum_length"))
        out.write(row.GetValue(canals_id) + "," + l_str + "\n")
        row = rows.Next()

    del row,rows

    out.close()
    gp.delete("temp.dbf")


except:
    #If an error occurred while running a tool, print the messages
    print gp.GetMessages(2)
